"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultContainerScope = exports.registerProvider = exports.Provider = exports.di = void 0;
const tslib_1 = require("tslib");
require("reflect-metadata");
const tsyringe_1 = require("tsyringe");
const injectable_1 = require("./injectable");
function di() {
    const child = tsyringe_1.container.createChildContainer();
    child.registerInstance('container', child);
    constructProviders(child);
    const groups = constructGroups(child);
    return { container: child, providers: [groups] };
}
exports.di = di;
let Provider = class Provider {
};
Provider = tslib_1.__decorate([
    (0, injectable_1.Injectable)()
], Provider);
exports.Provider = Provider;
const providerGroups = [];
const providerClasses = [];
function registerProvider(blueprints, ...providers) {
    providerGroups.push(blueprints);
    providers.map((it) => providerClasses.push(it));
}
exports.registerProvider = registerProvider;
function constructProviders(container) {
    for (const providerClass of providerClasses) {
        register(container, providerClass);
    }
}
function constructGroups(container) {
    const obj = new Provider();
    for (const providerClass of providerGroups) {
        for (const property in providerClass) {
            const group = providerClass[property];
            register(container, group);
        }
    }
    for (const providerClass of providerGroups) {
        for (const property in providerClass) {
            const group = providerClass[property];
            obj[property] = container.resolve(group);
        }
    }
    return obj;
}
exports.defaultContainerScope = { lifecycle: tsyringe_1.Lifecycle.ContainerScoped };
function register(container, provider) {
    container.register(provider, provider, exports.defaultContainerScope);
}
//# sourceMappingURL=registrars.js.map